--- old/usr/src/uts/common/fs/nfs/nfs3_srv.c	2013-01-13 14:59:43.711010954 +0400
+++ new/usr/src/uts/common/fs/nfs/nfs3_srv.c	2013-01-13 14:59:43.099010939 +0400
@@ -21,7 +21,7 @@
 /*
  * Copyright (c) 1994, 2010, Oracle and/or its affiliates. All rights reserved.
  *
- * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
  */
 
 /* Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T */
@@ -382,6 +382,10 @@
 
 	dvap = NULL;
 
+	/* Take an extra hold here in case of 'exi' switching */
+	if (exi != NULL)
+		exi_hold(exi);
+
 	/*
 	 * Allow lookups from the root - the default
 	 * location of the public filehandle.
@@ -433,8 +437,6 @@
 		goto out1;
 	}
 
-	exi_hold(exi);
-
 	/*
 	 * If the public filehandle is used then allow
 	 * a multi-component lookup
@@ -549,18 +551,15 @@
 	return;
 
 out:
-	/*
-	 * The passed argument exportinfo is released by the
-	 * caller, common_dispatch
-	 */
-	exi_rele(exi);
-
 	if (curthread->t_flag & T_WOULDBLOCK) {
 		curthread->t_flag &= ~T_WOULDBLOCK;
 		resp->status = NFS3ERR_JUKEBOX;
 	} else
 		resp->status = puterrno3(error);
 out1:
+	if (exi != NULL)
+		exi_rele(exi);
+
 	DTRACE_NFSV3_4(op__lookup__done, struct svc_req *, req,
 	    cred_t *, cr, vnode_t *, dvp, LOOKUP3res *, resp);
 
